#ifndef __kspread_functions_data_analysis__
#define __kspread_functions_data_analysis__

#include "kspread_functions_hlp.h"

void dafunc_sum(FloatVector& vector, EvaluationError& error, double& result);
void dafunc_count(FloatVector& vector, EvaluationError& error, double& result);
void dafunc_minimum(FloatVector& vector, EvaluationError& error, double& result, uint position = 1);
void dafunc_maximum(FloatVector& vector, EvaluationError& error, double& result, uint position = 1);
void dafunc_range(FloatVector& vector, EvaluationError& error, double& result);
void dafunc_average(FloatVector& vector, EvaluationError& error, double& result);
void dafunc_median(FloatVector& vector, EvaluationError& error, double& result);
void dafunc_kurtosis(FloatVector& vector, EvaluationError& error, double& result);
void dafunc_skewness(FloatVector& vector, EvaluationError& error, double& result);
void dafunc_variance(FloatVector& vector, EvaluationError& error, double& result);
void dafunc_standard_deviation(FloatVector& vector, EvaluationError& error, double& result);
void dafunc_standard_error(FloatVector& vector, EvaluationError& error, double& result);
void dafunc_anova_ss_total(FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_anova_df_total(FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_anova_single_ss_error(FloatVectorVector& vectorVector, EvaluationError& error, double& result);
void dafunc_anova_two_ss_error(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_anova_two_repl_ss_error(FloatVectorVector& cellVectorVector, FloatVector& vectorAll, uint rowsPerSample, EvaluationError& error, double& result);
void dafunc_anova_single_df_error(FloatVectorVector& vectorVector, FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_anova_two_df_error(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, EvaluationError& error, double& result);
void dafunc_anova_two_repl_df_error(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, uint rowsPerSample, EvaluationError& error, double& result);
void dafunc_anova_single_ms_error(FloatVectorVector& vectorVector, FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_anova_two_ms_error(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_anova_ss_effect(FloatVectorVector& vectorVector, FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_anova_two_repl_ms_error(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, FloatVectorVector& cellVectorVector, FloatVector& vectorAll, uint rowsPerSample, EvaluationError& error, double& result);
void dafunc_anova_two_repl_ss_interaction(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, FloatVectorVector& cellVectorVector, FloatVector& vectorAll, uint rowsPerSample, EvaluationError& error, double& result);
void dafunc_anova_two_repl_df_interaction(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, EvaluationError& error, double& result);
void dafunc_anova_two_repl_ms_interaction(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, FloatVectorVector& cellVectorVector, FloatVector& vectorAll, uint rowsPerSample, EvaluationError& error, double& result);
void dafunc_anova_df_effect(FloatVectorVector& vectorVector, EvaluationError& error, double& result);
void dafunc_anova_ms_effect(FloatVectorVector& vectorVector, FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_anova_single_f_stat(FloatVectorVector& vectorVector, FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_anova_two_f_stat(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_anova_two_repl_f_stat(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, FloatVectorVector& cellVectorVector, FloatVector& vectorAll, uint rowsPerSample, EvaluationError& error, double& result);
void dafunc_anova_two_repl_interaction_f_stat(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, FloatVectorVector& cellVectorVector, FloatVector& vectorAll, uint rowsPerSample, EvaluationError& error, double& result);
void dafunc_anova_two_f_dist(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_anova_two_repl_f_dist(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, FloatVectorVector& cellVectorVector, FloatVector& vectorAll, uint rowsPerSample, EvaluationError& error, double& result);
void dafunc_anova_two_repl_interaction_f_dist(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, FloatVectorVector& cellVectorVector, FloatVector& vectorAll, uint rowsPerSample, EvaluationError& error, double& result);
void dafunc_f_stat_variances(FloatVector& vector1, FloatVector& vector2, EvaluationError& error, double& result);
void dafunc_f_df(FloatVector& vector, EvaluationError& error, double& result);
void dafunc_f_test(FloatVector& vector1, FloatVector& vector2, EvaluationError& error, double& result);
void dafunc_anova_single_f_dist(FloatVectorVector& vectorVector, FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_anova_single_f_crit(FloatVectorVector& vectorVector, FloatVector& vectorAll, double p, EvaluationError& error, double& result);
void dafunc_anova_two_f_crit(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, double p, EvaluationError& error, double& result);
void dafunc_anova_two_repl_f_crit(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2, uint rowsPerSample, double p, EvaluationError& error, double& result);
void dafunc_anova_two_repl_interaction_f_crit(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector, uint rowsPerSample,  double p, EvaluationError& error, double& result);
void dafunc_f_crit_variances(FloatVector& vector1, FloatVector& vector2, double p, EvaluationError& error, double& result);
void dafunc_covariance(FloatVector& vector1, FloatVector& vector2, EvaluationError& error, double& result);
void dafunc_correlation(FloatVector& vector1, FloatVector& vector2, EvaluationError& error, double& result);
void dafunc_t_df_paired_means(FloatVector& vector, EvaluationError& error, double& result);
void dafunc_t_df_equal_variances(FloatVector& vector1, FloatVector& vector2, EvaluationError& error, double& result);
void dafunc_t_df_unequal_variances(FloatVector& vector1, FloatVector& vector2, EvaluationError& error, double& result);
void dafunc_t_stat_paired_means(FloatVector& vector1, FloatVector& vector2, double meanDifference, EvaluationError& error, double& result);
void dafunc_t_stat_equal_variances(FloatVector& vector1, FloatVector& vector2, double meanDifference, EvaluationError& error, double& result);
void dafunc_t_stat_unequal_variances(FloatVector& vector1, FloatVector& vector2, double meanDifference, EvaluationError& error, double& result);
void dafunc_t_test_paired_means(FloatVector& vector1, FloatVector& vector2, uint tails, double
 meanDifference, EvaluationError& error, double& result);
void dafunc_t_test_equal_variances(FloatVector& vector1, FloatVector& vector2, uint tails, double meanDifference, EvaluationError& error, double& result);
void dafunc_t_test_unequal_variances(FloatVector& vector1, FloatVector& vector2, uint tails, double meanDifference, EvaluationError& error, double& result);
void dafunc_t_crit_paired_means(FloatVector& vector1, FloatVector& vector2, double p, uint tails, EvaluationError& error, double& result);
void dafunc_t_crit_equal_variances(FloatVector& vector1, FloatVector& vector2, double p, uint tails, EvaluationError& error, double& result);
void dafunc_t_crit_unequal_variances(FloatVector& vector1, FloatVector& vector2, double p, uint tails, EvaluationError& error, double& result);
void dafunc_confidence_level(FloatVector& vector, double p, EvaluationError& error, double& result);
void dafunc_pooled_variance(FloatVectorVector& vectorVector, FloatVector& vectorAll, EvaluationError& error, double& result);
void dafunc_z_stat(FloatVector& vector1, FloatVector& vector2, double knownVariance1, double knownVariance2, double meanDifference, EvaluationError& error, double& result);
void dafunc_z_test(FloatVector& vector1, FloatVector& vector2, double knownVariance1, double knownVariance2, double meanDifference, uint tails, EvaluationError& error, double& result);
void dafunc_z_crit(double p, uint tails, EvaluationError& error, double& result);
void dafunc_moving_average(FloatVector& vector, uint position, uint interval, EvaluationError& error, double& result);
void dafunc_moving_average_standard_error(FloatVector& vector, uint position, uint interval, EvaluationError& error, double& result);
void dafunc_percent(FloatVector& sortedVector, uint k, EvaluationError& error, double& result);
void dafunc_rank(FloatVector& sortedVector, uint k, EvaluationError& error, double& result);
void dafunc_fast_fourier_transform(FloatVector& RealIn, bool inverseTransform, FloatVector& realOut, FloatVector& imagOut);
void dafunc_exponential_smoothing(FloatVector& vector, uint position, double alpha, EvaluationError& error, double& result);
void dafunc_exponential_smoothing_standard_error(FloatVector& vector, uint position, double alpha, EvaluationError& error, double& result);
void dafunc_frequency_vector(FloatVector& floatVector, FloatVector& binVector, EvaluationError& error, FloatVector& freqVector);
void dafunc_frequency_cumulative_percentage(FloatVector& floatVector, FloatVector& freqVector, uint position, EvaluationError& error, double& result);
void dafunc_regression_b_variables(FloatVectorVector& X, FloatVector& y, bool constantZero, EvaluationError& error, FloatVector& b);
void dafunc_regression_v_variables(FloatVector& b, FloatVectorVector& X, FloatVector& y, bool constantZero, EvaluationError& error, FloatVector& stdErrorVector);
void dafunc_regression_t_stat(FloatVector& b, FloatVector& stdErrorVector, uint position, EvaluationError& error, double& result);
void dafunc_regression_t_test(FloatVector& y, FloatVector& b, FloatVector& stdErrorVector, uint position, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_t_crit_lower(FloatVector& y, FloatVector& b, FloatVector& stdErrorVector, double confidenceLevel, uint position, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_t_crit_upper(FloatVector& y, FloatVector& b, FloatVector& stdErrorVector, double confidenceLevel, uint position, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_total_df(FloatVector& y, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_total_ss(FloatVector& y, bool constantZero,  EvaluationError& error, double& result);
void dafunc_regression_residuals_df(FloatVector& b, FloatVector& y, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_residuals_ss(FloatVector& b, FloatVectorVector& X, FloatVector& y, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_residuals_ms(FloatVector& b, FloatVectorVector& X, FloatVector& y, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_regression_df(FloatVector& b, EvaluationError& error, double& result);
void dafunc_regression_regression_ss(FloatVector& b, FloatVectorVector& X, FloatVector& y, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_regression_ms(FloatVector& b, FloatVectorVector& X, FloatVector& y, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_f_stat(FloatVector& b, FloatVectorVector& X, FloatVector& y, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_f_dist(FloatVector& b, FloatVectorVector& X, FloatVector& y, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_predicted_y(FloatVector& b, FloatVectorVector& X, uint position, EvaluationError& error, double& result);
void dafunc_regression_residuals(FloatVector& b, FloatVectorVector& X, FloatVector& y, uint position, EvaluationError& error, double& result);
void dafunc_regression_r_square(FloatVector& b, FloatVectorVector& X, FloatVector& y, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_multiple_r(FloatVector& b, FloatVectorVector& X, FloatVector& y, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_adjusted_r_square(FloatVector& b, FloatVectorVector& X, FloatVector& y, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_standard_error(FloatVector& b, FloatVectorVector& X, FloatVector& y, bool constantZero, EvaluationError& error, double& result);
void dafunc_regression_standarized_residuals(FloatVector& b, FloatVectorVector& X, FloatVector& y, uint position, EvaluationError& error, double& result);
void dafunc_random_numbers(FloatVector& vector, uint maxPos, uint numberOfElements, EvaluationError& error, FloatVector& result);
#endif
