#ifndef __kspread_functions_hlp__
#define __kspread_functions_hlp__

#include "../dataAnalysis_solver/kspread_functions_common.h"

#include <qstring.h>
#include <vector>
#include <qmap.h>
#include <kdebug.h>

typedef QMap<uint, double> FloatVector;
typedef std::vector<FloatVector> FloatVectorVector;

enum SortType {SortAscending,
			SortDescending};

enum EvaluationError {NoError,
					DivisionByZero,
					Number,
					NA,
					Impl};

#define DEFAULT_PRECISION 21

QString hlpfunc_result_string(EvaluationError error, double result, uint precision = DEFAULT_PRECISION);
QString hlpfunc_result_string(double& result, uint precision = DEFAULT_PRECISION);
FloatVector* hlpfunc_merge_vectors_content(FloatVector& vector1, FloatVector& vector2);
QStringVector* hlpfunc_merge_labels(QStringVector& vector1, QStringVector& vector2);
FloatVectorVector* hlpfunc_merge_vectors_vectors(FloatVectorVector& vectorVector1, FloatVectorVector& vectorVector2);
uint hlpfunc_max_vector_size(FloatVectorVector& vectorVector);
uint* hlpfunc_find_key(FloatVector& vector, double value);
void hlpfunc_sort(FloatVectorVector& vectorVectorIn, uint position, FloatVectorVector& vectorVectorOut, SortType sort = SortAscending);
void hlpfunc_sort(FloatVector& vectorIn, FloatVector& vectorOut, SortType sort = SortAscending);
bool hlpfunc_vectors_equals(FloatVector& vector1, FloatVector& vector2);
void hlpfunc_remove_not_paired_elements(FloatVector& vector1, FloatVector& vector2);
void hlpfunc_remove_empty_vectors(FloatVectorVector& floatVV, QStringVector& qStringV);
#endif


