#include "../dataAnalysis_solver/qeditbutton.h"
#include "kspread_dlg_data_analysis_template.h"
#include "kspread_inputrange1groupbox.h"

#include <kdebug.h>
#include <qframe.h>
#include <qvbox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qlayout.h>
#include <qgrid.h>


KSpreadInputRange1GroupBox::KSpreadInputRange1GroupBox(KDialogEditButton* dialog, QWidget* parent, const char* name)
 : QButtonGroup("Input", parent, name)
{
	inputLayout = new QVBoxLayout(this, dialog->marginHint(), dialog->spacingHint());

	QGrid* grid1 = new QGrid(2, this);
	inputLayout->addWidget(grid1);
	new QLabel("Input Range: ", grid1);
	QEditButton* inputRangeEB = new QEditButton(grid1, "Input Range");
	new QLabel("Grouped by: ",grid1);
	QVBox* groupedByBox = new QVBox(grid1);
	groupedByBox->setMargin(7);
	groupedByColumnsButton = new QRadioButton("Columns", groupedByBox, "groupedByColumnsButton");
	groupedByRowsButton = new QRadioButton("Rows", groupedByBox, "groupedByRowsButton");

	QGrid* grid2 = new QGrid(1, this);
	inputLayout->addWidget(grid2);
	labelsCheckBox = new QCheckBox("Labels in first row", grid2, "labelsCheckBox");
//	labelsCheckBox->setMinimumWidth(110);

	insert(groupedByRowsButton);
	insert(groupedByColumnsButton);

	connect(groupedByRowsButton, SIGNAL(clicked()), this, SLOT(slotChangeGroupByLabel()));
	connect(groupedByColumnsButton, SIGNAL(clicked()), this, SLOT(slotChangeGroupByLabel()));

	groupedByColumnsButton->toggle();
	inputRangeEB->setFocus();
}

void KSpreadInputRange1GroupBox::slotChangeGroupByLabel()
{
	QRadioButton* senderButton = (QRadioButton*)sender();
	if (senderButton == groupedByRowsButton)
		labelsCheckBox->setText("Labels in first column");
	else
		labelsCheckBox->setText("Labels in first row");
}


QVBoxLayout* KSpreadInputRange1GroupBox:: layout()
{
	return inputLayout;
}

#include "kspread_inputrange1groupbox.moc"
