#include "../dataAnalysis_solver/qeditbutton.h"
#include "kspread_dlg_data_analysis_template.h"
#include "kspread_inputrange2groupbox.h"

#include <kdebug.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <qgrid.h>


KSpreadInputRange2GroupBox::KSpreadInputRange2GroupBox(KDialogEditButton* dialog, QWidget* parent, const char* name, bool meanDifference, bool variablesVariance) : QGroupBox("Input", parent, name)
{
	inputLayout = new QVBoxLayout(this, dialog->marginHint(), dialog->spacingHint());

	QGrid* grid1 = new QGrid(2, this);
	inputLayout->addWidget(grid1);
	new QLabel("Variable 1 Range: ", grid1);
	QEditButton* variable1RangeEB = new QEditButton(grid1, "Variable 1 Range");
	variable1RangeEB->setMargin(3);
	new QLabel("Variable 2 Range: ", grid1);
	QEditButton* variable2RangeEB = new QEditButton(grid1, "Variable 2 Range");
	variable2RangeEB->setMargin(3);
	if (meanDifference)
	{
		QGrid* grid2 = new QGrid(2, this);
		inputLayout->addWidget(grid2);
		new QLabel("Hypothesized Mean Difference: ", grid2);
		QGrid* grid2a = new QGrid(1, grid2);
		grid2a->setMargin(3);
		new QLineEdit(grid2a, "meanDifferenceEdit");
	}

	if (variablesVariance)
	{
		QGrid* grid3 = new QGrid(2, this);
		inputLayout->addWidget(grid3);
		new QLabel("Variable 1 Variance (known): ", grid3);
		QGrid* grid3a = new QGrid(1, grid3);
		grid3a->setMargin(3);
		new QLineEdit(grid3a, "Variance 1");
		new QLabel("Variable 2 Variance (known): ", grid3);
		QGrid* grid3b = new QGrid(1, grid3);
		grid3b->setMargin(3);
		new QLineEdit(grid3b, "Variance 2");
	}

	QGrid* grid4 = new QGrid(1, this);
	inputLayout->addWidget(grid4);
	new QCheckBox("Labels", grid4, "labelsCheckBox");

	QGrid* grid5 = new QGrid(2, this);
	inputLayout->addWidget(grid5);
	new QLabel("Alpha: ", grid5);
	new QLineEdit("0.05", grid5, "alphaEdit");

	variable1RangeEB->setFocus();
}


QVBoxLayout* KSpreadInputRange2GroupBox:: layout()
{
	return inputLayout;
}

#include "kspread_inputrange2groupbox.moc"
