#include "../dataAnalysis_solver/qeditbutton.h"
#include "kspread_dlg_data_analysis_template.h"
#include "kspread_outputgroupbox.h"

#include <qframe.h>
#include <qvbox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qlayout.h>
#include <qgrid.h>


KSpreadOutputGroupBox::KSpreadOutputGroupBox(KDialogEditButton* dialog, QWidget* parent, bool all)
 : QButtonGroup("Output options", parent, "outputGroup")
{
	setMinimumWidth(270);
	outputLayout = new QVBoxLayout(this, dialog->marginHint(), dialog->spacingHint());
	QGrid* grid1 = new QGrid(2, this);
	outputLayout->addWidget(grid1);

	QRadioButton* outputRangeButton = new QRadioButton("Output Range: ", grid1, "outputRangeButton");
	QEditButton* outputRangeEB = new QEditButton(grid1, "Output Range");
	outputRangeEB->setMargin(3);

	QRadioButton* newWorksheetButton = new QRadioButton("New Worksheet Ply: ", grid1, "newWorksheetButton");
	QGrid* grid1a = new QGrid(1, grid1);
	QLineEdit* newWorksheetEdit = new QLineEdit(grid1a, "newWorksheetEdit");
	grid1a->setMargin(3);

//	QRadioButton* newWorkbookButton = new QRadioButton("New Workbook", grid1, "newWorksheetButton");
//	newWorkbookButton->setMinimumHeight(grid1a->height());

	insert(outputRangeButton);
	if (all)
	{	
		newWorksheetButton->toggle();
		outputRangeEB->setEnabled(false);
		dialog->connectFocus(outputRangeButton, outputRangeEB);
		dialog->connectFocus(newWorksheetButton, newWorksheetEdit);
//		dialog->connectFocus(newWorkbookButton, NULL);
		insert(newWorksheetButton);
//		insert(newWorkbookButton);
	}
	else
	{
		newWorksheetButton->setEnabled(false);
		newWorksheetEdit->setEnabled(false);
//		newWorkbookButton->setEnabled(false);
	}
}

QVBoxLayout* KSpreadOutputGroupBox::layout()
{
	return outputLayout;
}

#include "kspread_outputgroupbox.moc"
