#ifndef KSPREAD_PLUGIN_DATA_ANALYSIS_H
#define KSPREAD_PLUGIN_DATA_ANALYSIS_H

#include <kparts/plugin.h>
#include <koffice_export.h>
#include <qdatetime.h>

#include "kspread_dlg_data_analysis_main.h"

class KAboutData;
class KSpread::View;


class KSPREAD_EXPORT PluginDataAnalysis : public KParts::Plugin
{
  Q_OBJECT

  protected:

    /**
     * This is the parent part of the plugin. It is used
     * to access the spreadsheet.
     *
     * It is set in the constructor.
     */
    KSpread::View* m_kspreadView;
    KSpreadDlgDataAnalysisMain* m_dialog;

  public:

    /**
     * Constructor. This constructor is usable with KGenericFactory.
     */
    PluginDataAnalysis( QObject *parent, const char *name, const QStringList& args);

    /**
     * Virtual destructor.
     */
    virtual ~PluginDataAnalysis();

  public:

    /**
     * Creates about data.
     */
    static KAboutData* createAboutData();

  public slots:

     /**
      * This is called from the plugin action, it shows a dialog.
      */
     void slotDlgDataAnalysisShow();
     void slotDlgDataAnalysisDestroyed();
};

#endif
