
#include "qeditbutton.h"

#include <kdebug.h>
#include <qapplication.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qwidget.h>
#include <qgrid.h>
#include <vector>

QEditButton::QEditButton(QWidget* parent, const char* name, WFlags f)  : QGrid(2, parent, name, f)
{
	this->parent = parent;
	edit = new QLineEdit(this, name);
//s	setFocusProxy(edit);
	button = new QPushButton(this);
	button->setText("...");
	button->setFocusPolicy(QWidget::NoFocus);
	canEmpty = false;

	connect(button, SIGNAL(released()), this, SLOT(slotSetEditFocus()));
	
	connect(edit, SIGNAL(textChanged(const QString &)), SIGNAL(textChanged(const QString &)));
	connect(edit, SIGNAL(returnPressed()), SIGNAL(returnPressed()));
	connect(edit, SIGNAL(lostFocus()), SIGNAL(lostFocus()));
	connect(edit, SIGNAL(selectionChanged()), SIGNAL(selectionChanged()));
	connect(button, SIGNAL(pressed()), SIGNAL(pressed()));
	connect(button, SIGNAL(released()), SIGNAL(released()));
	connect(button, SIGNAL(clicked()), SIGNAL(clicked()));
	
	edit->installEventFilter(this);
};
	
bool QEditButton::eventFilter(QObject* watched, QEvent* e)
{
	if (e->type() == QEvent::Show)
	{
		button->setMinimumSize(edit->height(), edit->height());
		button->setMaximumSize(edit->height(), edit->height());
	}
	else
	if (e->type() == QEvent::FocusIn)
	{
		qApp->sendEvent(this, new QEvent(QEvent::FocusIn));
	}
	else
	if (e->type() == QEvent::FocusOut)
	{
		qApp->sendEvent(this, new QEvent(QEvent::FocusOut));
	}
	return false;
};
	
void QEditButton::slotSetEditFocus()
{
	edit->setFocus();
};

void QEditButton::setFocus()
{
	edit->setFocus();	
}

void QEditButton::setEditText(const QString& string)
{
	edit->setText(string);
}
	
QString QEditButton::editText()
{
	return edit->text();
};

void QEditButton::setCanBeEmpty(bool empty)
{
	canEmpty = empty;
}

bool QEditButton::canBeEmpty()
{
	return canEmpty;
}

#include "qeditbutton.moc"
