#ifndef __qeditbutton__
#define __qeditbutton__

#include <vector>
#include <qgrid.h>
#include <qwidget.h>

class QPushButton;
class QLineEdit;
class QWidget;

class QEditButton : public QGrid
{
	Q_OBJECT
public:
	QEditButton(QWidget* parent = 0, const char* name = 0, WFlags f = 0);
	virtual bool eventFilter(QObject * watched, QEvent * e);
	virtual void setFocus();
	void setEditText(const QString& strings);
	QString editText();
	void setCanBeEmpty(bool empty);
	bool canBeEmpty();
private:
	
	QPushButton* button;
	QLineEdit* edit;
	QWidget* parent;
	bool canEmpty;
private slots:
	void slotSetEditFocus();
signals:
	void pressed();
	void released();
	void clicked();
	void textChanged(const QString &);
	void returnPressed();
	void lostFocus();
	void selectionChanged();
};

#endif
