#ifndef KSPREAD_PLUGIN_SOLVER_H
#define KSPREAD_PLUGIN_SOLVER_H

#include <kparts/plugin.h>
#include <koffice_export.h>

class KAboutData;
class KSpreadDlgSolverMain;

namespace KSpread
{
	class View;
}

class KSPREAD_EXPORT PluginSolver : public KParts::Plugin
{
  Q_OBJECT

  protected:

    KSpread::View* kspreadView;
    KSpreadDlgSolverMain* m_dialog;
    bool dialogIsVisible;

  public:

    /**
     * Constructor. This constructor is usable with KGenericFactory.
     */
    PluginSolver( QObject *parent, const char *name, const QStringList& args);

    /**
     * Virtual destructor.
     */
    virtual ~PluginSolver();

  public:

    /**
     * Creates about data.
     */
    static KAboutData* createAboutData();

  public slots:

     /**
      * This is called from the plugin action, it shows a dialog.
      */
     void slotDlgSolverShow();
     void slotDlgSolverHidden();
};

#endif
